#ifndef __aspconfig_h_included__
#define __aspconfig_h_included__

static inline void connect_led_on() {
    /* GREEN or YELLOW on */
    PORTD |= (1<< PD7);
    DDRD  |= (1<< PD7);
}

static inline void connect_led_off() {
    /* GREEN or YELLOW off */
    DDRD  &= ~(1<< PD7);
    PORTD &= ~(1<< PD7);
}

static inline void busy_led_on() {
    /* RED or ORANGE off : reversed */
    //DDRD  &= ~(1<< PD6);
    PORTD &= ~(1<< PD6);
    DDRD  |= (1<< PD6);
}

static inline void busy_led_off() {
    /* RED or ORANGE on : reversed */
    PORTD |= (1<< PD6);
    DDRD  |= (1<< PD6);
}

#define ENABLE_ISP1
#define ISP_OUT   PORTB
#define ISP_IN    PINB
#define ISP_DDR   DDRB
#define ISP_RST   PB0	/* SS */
#define ISP_MOSI  PB2	/* MOSI = ISP MOSI */
#define ISP_MISO  PB3	/* MISO = ISP MISO */
#define ISP_SCK   PB1	/* SCLK */

#define ISP2_OUT   PORTD
#define ISP2_IN    PIND
#define ISP2_DDR   DDRD
#define ISP2_RST   PD1
#define ISP2_MOSI  PD3	/* MOSI = TX */
#define ISP2_MISO  PD2	/* MISO = RX */
#define ISP2_SCK   PD5	/* SCLK = XCK */
#define ISP2_DIR   PD4	/* for buffer control - L: TX , H or Hi-Z: RX */

#define ENABLE_ISP2
#define ENABLE_PDI
#define ENABLE_TPI
#define ENABLE_HARD_PDITPI
//#define ENABLE_SOFT_PDITPI
//#define ENABLE_SOFT_XXX

static inline void pditpi_dir_init() {
	ISP2_OUT |= (1<< ISP2_DIR);
	ISP2_DDR |= (1<< ISP2_DIR);
}

static inline void pditpi_dir_tx() {
	ISP2_OUT &= ~(1<< ISP2_DIR);
}

static inline void pditpi_dir_rx() {
	ISP2_OUT |= (1<< ISP2_DIR);
}

static inline int8_t pditpi_dir_is_tx() {
	return !(ISP2_OUT & (1<< ISP2_DIR));
}

static inline void tpi_reset(uchar is_assert) {
#ifdef ISP2_RST
	if (is_assert) {
		ISP2_DDR |=(1<< ISP2_RST); // L 
	} else {
		ISP2_DDR &= ~(1<< ISP2_RST); // HI-Z
	}
#endif
}

#ifdef SERIAL_DEBUG
extern void debug_putc(uint8_t ch);
extern void debug_puts(char *buf);
extern void debug_put_hex(uint8_t v);
#endif
#endif /* __aspconfig_h_included__ */
